function varargout = MinInversion(varargin)
%MININVERSION MATLAB code file for MinInversion.fig
%      MININVERSION, by itself, creates a new MININVERSION or raises the existing
%      singleton*.
%
%      H = MININVERSION returns the handle to a new MININVERSION or the handle to
%      the existing singleton*.
%
%      MININVERSION('Property','Value',...) creates a new MININVERSION using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to MinInversion_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      MININVERSION('CALLBACK') and MININVERSION('CALLBACK',hObject,...) call the
%      local function named CALLBACK in MININVERSION.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help MinInversion

% Last Modified by GUIDE v2.5 14-Nov-2017 10:45:29


% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % 
% % Copyright 2017   MinInversion Amosu Adewale
% %  Redistribution and use in source and binary forms, with or without
% % modification, are permitted provided that the following conditions are met: 
% % 1. The theory and software papers describing the theory and use of the software 
% % are cited and referenced.  
% % 2. Redistributions of source code must retain the 
% % above copyright notice, this list of conditions and the following disclaimer. 
% % 3. Redistributions in binary form must reproduce the above copyright notice, 
% % this list of conditions and the following disclaimer in the documentation 
% % and/or other materials provided with the distribution. 
% % 4. Neither the name of the copyright holder nor the names of its 
% % contributors may be used to endorse or promote products derived from this 
% % software without specific prior written permission. THIS SOFTWARE IS 
% % PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
% % OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
% % OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
% % IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY 
% % DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
% % (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% % LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND 
% % ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
% % (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
% % THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @MinInversion_OpeningFcn, ...
                   'gui_OutputFcn',  @MinInversion_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before MinInversion is made visible.
function MinInversion_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for MinInversion
handles.output = hObject;

% Update handles structure
set(handles.axes1,'Yticklabel',[]);
set(handles.axes1,'Xticklabel',[]);
methodnames={'Least Squares';'Moore-Penrose';'luDecomposition'};
set(handles.listbox1_methods,'string',methodnames,'fontsize',12);
handles.msg='';
warning off;
guidata(hObject, handles);


% UIWAIT makes MinInversion wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = MinInversion_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function edit1_Callback(hObject,eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton1_load_las.
function pushbutton1_load_las_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1_load_las (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%nome: input filename. Has to be well formatted.
%lastable: output in matlab table format
%header information
%if no input file is supplied navigate to select file in popup
%Author: Adewale Amosu,Texas A&M University.


%check for input
if (nargin<4) 
[nome,pathname]=uigetfile({'*las;*.LAS'});  else pathname='';
end
FileName=fullfile([pathname,nome]);
if (FileName == 0)
set(handles.edit1,'String','Input file is not selected')
pause(1)
set(handles.edit1,'String','Status')
return;
end

if ischar(nome)
fid=fopen(FileName);
count=0; header=''; lognamelistflag=0; headerblockflag=0; 

%get header and log names
while ~headerblockflag
inputline=fgetl(fid);
if ~ischar(inputline); break, end
    header=char(header,inputline);
    %if there exists '~A' skip loop % begining of ~A (ASCII LOG DAT A)
    if any(strncmpi('~A',inputline,2)); lognamelistflag=0; headerblockflag=1; end
    if lognamelistflag && any(strncmp('~',inputline,1)); lognamelistflag=0; end %if there exists '~CURVE' and '~' dont get name
    if lognamelistflag && ~strcmp(inputline(1),'#') %if there exists '~CURVE' and no '#' get name
        count=count+1; lognames{count}=inputline;
    end
    if any(strncmpi('~CURVE',inputline,6)), lognamelistflag=1; headerblockflag=0; end %if there exists '~CURVE' set to 1:  %~Curve Information Section   
end


%now get datavalues
datavalues=fscanf(fid,'%f');
datavalues=reshape(datavalues,[count length(datavalues)/count])';
fclose(fid);

%check for placeholders
datavalues(datavalues<=-999)=nan;
set(handles.edit1,'String',['Extracted ' num2str(count) ' wireline logs from file ' nome]); 

%split variables names and units, remove whitespaces and '_'
for k=1:length(lognames)
    C = strsplit(lognames{k},{'.',':'},'CollapseDelimiters',true);
    lognames{k}=strtrim(C(1,1)); lognames{k}=regexprep(lognames{k},'_','');lognames{k}=char(lower(lognames{k}));
    logunits{k}=strtrim(C(1,2));
    
% if ~isvarname(lognames{k})
%    disp(lognames{k});
% end
end

%compile in table
lastable = array2table(datavalues,'VariableNames',lognames);dvar=width(lastable);
handles.nLogs=dvar;
% f = figure;
% uitable('Data',lastable{:,:},'ColumnName',lastable.Properties.VariableNames,'Units', 'Normalized', 'Position',[0, 0, 1, 1]);

%%%--------------------------%%%
% pause(1)
% set(handles.edit1,'String','Status');
handles.LAStable=lastable;
handles.LASnames=lognames;
handles.LASunits=logunits;
handles.LASheader=header;
guidata(hObject,handles);
%%%--------------------------%%%
end


% --- Executes on button press in pushbutton2_loadAsciiXls.
%%%%%%%%%%%  Load Ascii or Excel or CSV 
function pushbutton2_loadAsciiXls_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2_loadAsciiXls (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
warning off;
[PathName,FileName] = uigetfile({'*.txt;*.csv;*.xlsx'},'Select the Data file');
if (FileName == 0)
set(handles.edit1,'String','Input file is not selected')
pause(1)
set(handles.edit1,'String','Status')
return;
end

[~,~,ext] = fileparts(fullfile(FileName,PathName)) ;
if strcmp(ext,'.csv')
    d=readtable(fullfile(FileName,PathName),'Delimiter',',');dvar=width(d);
else
d=readtable(fullfile(FileName,PathName));dvar=width(d);
end
handles.LogASC=d;
handles.nLogs=dvar;
guidata(hObject,handles);

% f = figure;
% uitable('Data',handles.LogASC{:,:},'ColumnName',handles.LogASC.Properties.VariableNames,'Units', 'Normalized', 'Position',[0, 0, 1, 1]);
set(handles.edit1,'String',[num2str(dvar) ' logs extracted from file ']);
% pause(1)
% set(handles.edit1,'String','Status')

guidata(hObject,handles);



% --- Executes on button press in pushbutton3_plotlogs.
%%%%%%%%%%%   View Logs 
function pushbutton3_plotlogs_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3_plotlogs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.edit1,'String','Please Wait...')
if ~isfield(handles,'DEP')
set(handles.edit1,'String','Please first "Select Logs" to use...')    
return
end

dtop=min(handles.DEP);dbot=max(handles.DEP);
prompt = {'Enter Zone Top Depth:','Enter Zone Bottom Depth'};
dlg_title = 'Input';
num_lines = 1;
defaultans = {num2str(dtop),num2str(dbot)};
answer = inputdlg(prompt,dlg_title,num_lines,defaultans);
dtop=str2num(answer{1});
dbot=str2num(answer{2});
handles.dtop=dtop;
handles.dbot=dbot;
guidata(hObject,handles);
viewlogss(hObject, eventdata, handles)
set(handles.edit1,'String','Status')


% --- Executes on selection change in listbox1_methods.
%%%%% List Box methods
function listbox1_methods_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1_methods (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1_methods contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1_methods


% --- Executes during object creation, after setting all properties.
function listbox1_methods_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1_methods (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox2_selectedinfo.
%%%%%%%  List bix logs and Minerals
function listbox2_selectedinfo_Callback(hObject, eventdata, handles)
% hObject    handle to listbox2_selectedinfo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox2_selectedinfo contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox2_selectedinfo


% --- Executes during object creation, after setting all properties.
function listbox2_selectedinfo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox2_selectedinfo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in listbox3.
function listbox3_Callback(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox3 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox3


% --- Executes during object creation, after setting all properties.
function listbox3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in radiobutton1.
function radiobutton1_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton1


% --- Executes on button press in pushbutton4_invert.
%%%%%%%%%% Invert Button
function pushbutton4_invert_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4_invert (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ~isfield(handles,'logFIN')
set(handles.edit1,'String','Please Load and Select Logs')    
    return;
end

%close open figures
set(MinInversion, 'HandleVisibility', 'off');
close all;
set(MinInversion, 'HandleVisibility', 'on');


logFIN=handles.logFIN;
[mt,nt]=size(logFIN);

%%if ~isfield(handles,'dtop')
dtop0=min(handles.DEP);dbot0=max(handles.DEP);
prompt = {'Enter Zone Top Depth:','Enter Zone Bottom Depth'};
dlg_title = 'Input';
num_lines = 1;
defaultans = {num2str(dtop0),num2str(dbot0)};
answer = inputdlg(prompt,dlg_title,num_lines,defaultans);
dtop=str2num(answer{1});
dbot=str2num(answer{2});

if (dtop < dtop0);dtop=dtop0;end
if (dbot > dbot0);dbot=dbot0;end

Ishort=find(handles.DEP >= dtop & handles.DEP <= dbot);
handles.DEPshort=handles.DEP(Ishort);
if isfield(handles,'POR')
handles.PORshort=handles.POR(Ishort);
end

handles.Ishort=Ishort;
handles.dtop=dtop;
handles.dbot=dbot;
logFINshort=handles.logFIN(Ishort,:);
handles.logFINshort=logFINshort;
guidata(hObject,handles);


if ~isfield(handles,'panhandle')
panhandle = uipanel('Position', [0.258 0.124 0.689 0.746]);
handles.panhandle=panhandle;
[ml,nl]=size(handles.logFINshort);
handles.numplts=nl+1;if isfield(handles,'POR'); handles.numplts=nl+2;end
end

set(handles.edit1,'String','Please Wait... Computing...')
pause(0.1)
guidata(hObject,handles); 
if (nt < 3);set(handles.edit1,'String','Warning: Works best if 3 or more logs are used (excluding Depth & NPHI) ');end

if ~isfield(handles,'PORshort')%%%%should be ~isfield
     if ~isfield(handles,'ddUSED')
        set(handles.edit1,'String','Select Constituents')
     return   
    end
  A1=handles.ddUSED(:,2:end);A1=cell2mat(A1)';
  A2=handles.ddflUSED(1,2:end);A2=cell2mat(A2)';
  A=[A1 A2];
  
[m,n]=size(A);
A(m+1,:)=1;


for jj=1:length(handles.DEPshort)
        B(1:n-1)=logFINshort(jj,1:n-1);
    B(n)=1;
    Xp(:,jj)=solveforX(hObject, eventdata, handles,A,B);
end
handles.Xp=Xp;
X = cumsum(Xp,1);handles.RESULT2=X;
guidata(hObject,handles);
viewlogss(hObject, eventdata, handles);
numplts=handles.numplts;
subplot(1,numplts+1,[numplts numplts+1],'Parent',handles.panhandle)
add_litho2(hObject, eventdata, handles,handles.DEPshort',X);
set(handles.edit1,'String','Status')
guidata(hObject,handles); 
%%%%%
else
    if ~isfield(handles,'ddUSED')
        set(handles.edit1,'String','Select Constituents')
     return   
    end
    A=handles.ddUSED(:,2:end);A=cell2mat(A)';
  A2=handles.ddflUSED(1,2:end);A2=cell2mat(A2);
  
[m,n]=size(A);
A(m+1,:)=1;

tic;
for jj=1:length(handles.DEPshort)
        B(1:n)=logFINshort(jj,:)-A2.*handles.PORshort(jj);
    B(n+1)=1-handles.PORshort(jj);
    Xp(:,jj)=solveforX(hObject, eventdata, handles,A,B);
end
te=toc;
disp(['Time elapsed is :' num2str(te)]);
handles.Xp=Xp;
X = cumsum(Xp,1);handles.RESULT=X;
guidata(hObject,handles);
viewlogss(hObject, eventdata, handles);
numplts=handles.numplts;
subplot(1,numplts+1,[numplts numplts+1],'Parent',handles.panhandle)
add_litho(hObject, eventdata, handles,handles.DEPshort',X);
set(handles.edit1,'String','Status')
end


if isfield(handles,'POR')
hfig=figure('Units', 'norm','Position',[0.4 0 0.6 0.9]);
probtrends(handles)
end
% ---------------------------------------------------------------

function add_litho(hObject, eventdata, handles,dep,X)
[m, n]=size(X);
col=simpcol();
col=flipud(col);
xzero=zeros(1, n);xone=ones(1, n);
XX(1,:)=xzero;XX(2:m+1,:)=X(1:m,:); XX(m+2,:)=xone;
for jj=1:m+1
polygx(jj,:)=[XX(jj,:) fliplr(XX(jj+1,:))];
polygy(jj,:)=[dep fliplr(dep)];
patch(polygx(jj,:),polygy(jj,:),col(jj),'FaceColor',col(jj,:),'EdgeColor',col(jj,:));
xlabel('Volume Fraction','Fontsize',15); ylabel('Depth(ft)','Fontsize',15)
set(gca,'Ydir','reverse','XAxisLocation','top','Fontweight','bold','YAxisLocation','right');
xlim([0 1]);
ylim([handles.dtop handles.dbot]);
end
hold on
hplp=plot(gca,1-handles.POR,handles.DEP,'r-','Linewidth',2);
%hasbehavior(hplp,'legend',false);
hl=legend([ handles.ddUSED(:,1); {' Inverted Porosity'}; {' Measured Porosity'}]);
set(hl,'Fontsize',12,'Location','Best');

function add_litho2(hObject, eventdata, handles,dep,X)
[m, n]=size(X);
col=simpcol();
col=flipud(col);
xzero=zeros(1, n);xone=ones(1, n);
XX(1,:)=xzero;XX(2:m+1,:)=X(1:m,:);
for jj=1:m
polygx(jj,:)=[XX(jj,:) fliplr(XX(jj+1,:))];
polygy(jj,:)=[dep fliplr(dep)];
patch(polygx(jj,:),polygy(jj,:),col(jj),'FaceColor',col(jj,:),'EdgeColor',col(jj,:));
xlabel('Volume Fraction','Fontsize',15); ylabel('Depth(ft)','Fontsize',15)
set(gca,'Ydir','reverse','XAxisLocation','top','Fontweight','bold','YAxisLocation','right');
xlim([0 1]);
ylim([handles.dtop handles.dbot]);
end
hl=legend([ handles.ddUSED(:,1); {' Inverted Porosity'}]);
set(hl,'Fontsize',12,'Location','Best');

% --- Executes on button press in pushbutton6_chooseComponents.
%%%%%% Select Contituents
function pushbutton6_chooseComponents_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6_chooseComponents (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
choix = questdlg('Select Mineral set','Mineral Selection', 'Default Mineral Set','New Mineral Set','Close','Close');
% Handle response
switch choix
    case 'Default Mineral Set'
    defaultminset(hObject, eventdata, handles)  
    case 'New Mineral Set'
    newminset(hObject, eventdata, handles) 
    case 'Close'
        disp('exiting...')
end

function defaultminset(hObject, eventdata, handles)
% str={'Quartz';'Dolomite'; 'Calcite'; 'Shale'; 'Chert';'Aragonite';'Magnesite'};
% [s,v] = listdlg('PromptString','Hold Cntrl or CMD to Select Multiple components','SelectionMode','Multiple','ListString',str);
if ~isfield(handles,'LAStable');
    set(handles.edit1,'String','First Load and Select Logs');
    return;
end
if ~isfield(handles,'valLoc')
    set(handles.edit1,'String','First Load and Select Logs');
    return;
end
valLOC1=handles.valLoc(handles.valLoc <= 8);
valLOC2=handles.valLoc(handles.valLoc > 8);
handles.dep=handles.LAStable(:,1);

nv=length(valLOC1);
f = figure('Position',[20 20 850 450],'Name',['Select ' num2str(nv) ' Constituents ']);
cnames={'Mineral';'DENS(g/cc)';'DT(usec/ft)';'DTS(usec/ft)';'VP(m/s)';'VS(m/s)';'PE';'K(Gpa)';'mu(Gpa)';'Select'};
handles.t = uitable(f,'ColumnEditable',true,'ColumnName',cnames);


d = {'Quartz',2.65,43.9,88.8,6037.618,4120.817,1.82,36.6,45,false;...   
'Shale',2.6,62.5,150,2559.92,1129.865,3.42,11.4,3,false;...
'Calcite',2.71,47.2,89.9,2559.92,3436.294,5.09,76.8,32,false;...
'Clay',2.65,64.3,98.9,5966.288,3079.512,3.03,62.2,25.7,false;...
'Dolomite',2.87,43.9,74.8,7346.572,3959.728,3.13,94.9,45,false;
'Anhydrite',2.95,50,85,6105.553,3366.502,5.08,66.5,34,false;...
'Gypsum',2.35,52.4,85.4,6513.389,3603.75,4.04,58,30,false;...
'Muscovite',2.83,47.2,91.1,5773.503,3342.187,2.4,52,31.5,false;...
'Biotite',3.2,55.5,100.6,5374.838,3027.65,8.59,50,27.5,false;...
'Kaolinite',2.64,64.3,101.7,5637.622,2995.899,1.47,48.35,21.9,false;...
'Glauconite',2.83,55.5,157.4,3257.566,1935.282,4.77,15,10,false;...
'Illite',2.77,64.3,98.9,5966.288,3079.512,3.03,62.2,25.7,false;...
'Chlorite',2.75,55.5,61.3,9268.864,4969.107,4.77,146.25,68.15,false;...
'Orthoclase',2.54,68.9,84.9,4926.98,3586.239,2.87,17.96,32.41,false;...
'Siderite',3.91,43.9,84.9,6957.664,3588.703,14.3,123.7,51,false;...
'Pyrite',5,39.6,55.9,8429.065,5448.052,16.4,158,149,false;...
'Halite',2.03,6.7,114.5,4594.683,2661.453,4.72,25.2,15.3,false};


dd=d(:,[1 valLOC1+1]);  %% fix fluid later 17 to 19
if ~isfield(handles,'t');return;end
handles.t.Data = d;
handles.t.Position = [20 20 800 400];
guidata(hObject,handles);
btnM = uicontrol('Parent',f,'Style', 'pushbutton', 'String', 'Save','Position', [740 420 50 30],'Callback','uiresume(gcbf)');   
uiwait(gcf);

if ~isvalid(handles.t);return;end
Tdat= get(handles.t,'Data');
handles.TdatUSED=Tdat([Tdat{:,10}]>0,:);
if isempty(handles.TdatUSED)
set(handles.edit1,'String','No Constituents Selected')
pause(1)
set(handles.edit1,'String','Status')
end
ddUSED=dd([Tdat{:,10}]>0,:);
handles.ddUSED=ddUSED;
handles.MinUSED=handles.TdatUSED(:,1);
nu=length(handles.MinUSED);
set(handles.edit1,'String','Status')
if (nu > nv)
    set(handles.edit1,'String','System Underdetermined, Reselect constituents');
    close(gcf);
    return
elseif (nu < nv)
    set(handles.edit1,'String','System Overdetermined, Reselect constituents');
    close(gcf);
    return
end

if ~isfield(handles,'MinUSED');handles.MinUSED='NONE';end
msg=['Min Used: '; handles.MinUSED];
set(handles.listbox3,'String',msg);
guidata(hObject,handles);
close(gcf);

ffl = figure('Position',[20 20 850 450],'Name','Select 1 Fluid');
cnames={'Fluid';'DENS(g/cc)';'DT(usec/ft)';'DTS(usec/ft)';'VP(m/s)';'VS(m/s)';'PE';'K(Gpa)';'mu(Gpa)';'Select'};
handles.tfl = uitable(ffl,'ColumnEditable',true,'ColumnName',cnames);

dfl = {'FreshWater',1,205,-999.25,1482,-999.25,0.36,-999.25,-999.25,false;...
'Brine',1.1,188,-999.25,1522,-999.25,0.81,-999.25,-999.25,false;...
'Oil',0.85,238,-999.25,1280,-999.25,0.12,-999.25,-999.25, false};

ddfl=dfl(:,[1 valLOC1+1]);  
if ~isfield(handles,'tfl');return;end
handles.tfl.Data = dfl;
handles.tfl.Position = [20 20 800 400];
guidata(hObject,handles);
btnM = uicontrol('Parent',ffl,'Style', 'pushbutton', 'String', 'Save','Position', [740 420 50 30],'Callback','uiresume(gcbf)');   
uiwait(gcf);

if ~isvalid(handles.tfl);return;end
Tfldat= get(handles.tfl,'Data');
handles.TfldatUSED=Tfldat([Tfldat{:,10}]>0,:);
if isempty(handles.TfldatUSED)
set(handles.edit1,'String','No Fluid Selected')
pause(1)
set(handles.edit1,'String','Status')
end
ddflUSED=ddfl([Tfldat{:,10}]>0,:);
handles.ddflUSED=ddflUSED;
handles.flUSED=handles.TfldatUSED(:,1);
msg=get(handles.listbox3,'String');
msg=[msg; 'Fluid Used: '; handles.flUSED];
set(handles.listbox3,'String',msg);
guidata(hObject,handles);
close(gcf);



function btnM_callback(hObject, eventdata,handles)
guidata(hObject,handles);


function newminset(hObject, eventdata, handles)
[PathName,FileName] = uigetfile({'*.txt;*.csv;*.xlsx;*.xls'},'Select the Data file');
if ~isfield(handles,'LAStable');set(handles.edit1,'String','First Load and Select Logs');return;end
valLOC1=handles.valLoc(handles.valLoc <= 8);
valLOC2=handles.valLoc(handles.valLoc > 8);
handles.dep=handles.LAStable(:,1);

nv=length(valLOC1);
f = figure('Position',[20 20 850 450],'Name',['Select ' num2str(nv) ' Constituents']);
cnames={'Mineral';'DENS(g/cc)';'DT(usec/ft)';'DTS(usec/ft)';'VP(m/s)';'VS(m/s)';'PE';'K(Gpa)';'mu(Gpa)';'Select'};
handles.t = uitable(f,'ColumnEditable',true,'ColumnName',cnames);


if (FileName == 0)
set(handles.edit1,'String','Min Set is not selected')
pause(1)
set(handles.edit1,'String','Status')
return;
end

[~,~,ext] = fileparts(fullfile(FileName,PathName)) ;
if strcmp(ext,'.csv')
    d=readtable(fullfile(FileName,PathName),'Delimiter',',');dvar=width(d);
else
d=readtable(fullfile(FileName,PathName));dvar=width(d);
end


d=table2cell(d);
[dhgt,~] = size(d);
for k=1:dhgt; d{k,10}=false; end
dd=d(:,[1 valLOC1+1]);
if ~isfield(handles,'t');return;end
handles.t.Data = d ;
handles.t.Position = [20 20 800 400];
guidata(hObject,handles);
btnM = uicontrol('Parent',f,'Style', 'pushbutton', 'String', 'Save','Position', [740 420 50 30],'Callback','uiresume(gcbf)');   
uiwait(gcf);

if ~isvalid(handles.t);return;end
Tdat= get(handles.t,'Data');
handles.TdatUSED=Tdat([Tdat{:,10}]>0,:);
if isempty(handles.TdatUSED)
set(handles.edit1,'String','No Constituents Selected')
pause(1)
set(handles.edit1,'String','Status')
end
ddUSED=dd([Tdat{:,10}]>0,:);
handles.ddUSED=ddUSED;
handles.MinUSED=handles.TdatUSED(:,1);
if ~isfield(handles,'MinUSED');handles.MinUSED='NONE';end
msg=['Min Used: '; handles.MinUSED];
set(handles.listbox3,'String',msg);
close(gcf);


ffl = figure('Position',[20 20 850 450],'Name','Select 1 Fluid');
cnames={'Fluid';'DENS(g/cc)';'DT(usec/ft)';'DTS(usec/ft)';'VP(m/s)';'VS(m/s)';'PE';'K(Gpa)';'mu(Gpa)';'Select'};
handles.tfl = uitable(ffl,'ColumnEditable',true,'ColumnName',cnames);

dfl = {'FreshWater',1,205,-999.25,1482,-999.25,0.36,-999.25,-999.25,false;...
'Brine',1.086,188,-999.25,1522,-999.25,0.81,-999.25,-999.25,false;...
'Oil',0.85,-999.25,-999.25,-999.25,-999.25,0.12,-999.25,-999.25, false};

ddfl=dfl(:,[1 valLOC1+1]);  
if ~isfield(handles,'tfl');return;end
handles.tfl.Data = dfl;
handles.tfl.Position = [20 20 800 400];
guidata(hObject,handles);
btnM = uicontrol('Parent',ffl,'Style', 'pushbutton', 'String', 'Save','Position', [740 420 50 30],'Callback','uiresume(gcbf)');   
uiwait(gcf);

if ~isvalid(handles.tfl);return;end
Tfldat= get(handles.tfl,'Data');
handles.TfldatUSED=Tfldat([Tfldat{:,10}]>0,:);
if isempty(handles.TfldatUSED)
set(handles.edit1,'String','No Fluid Selected')
pause(1)
set(handles.edit1,'String','Status')
end
ddflUSED=ddfl([Tfldat{:,10}]>0,:);
handles.ddflUSED=ddflUSED;
handles.flUSED=handles.TfldatUSED(:,1);
msg=get(handles.listbox3,'String');
msg=[msg; 'Fluid Used: '; handles.flUSED];
set(handles.listbox3,'String',msg);
guidata(hObject,handles);
close(gcf);



% --- Executes on button press in pushbutton9.
%%%%%%%% Select Logs
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isfield(handles,'LAStable')
%    display('LAStable');
     %f = figure;
     %uitable('Data',handles.LAStable{:,:},'ColumnName',handles.LAStable.Properties.VariableNames,'Units', 'Normalized', 'Position',[0, 0, 1, 1]);
     [m,n]=size(handles.LAStable{:,:});
     dd{2,n}=[];for jj=1:n;dd{1,jj}=false;end;dd(2,:)=handles.LAStable.Properties.VariableNames;
     %%dd{m+2,n}=[];%dd(3:m+2,1:n)=table2cell(handles.LAStable);
elseif isfield(handles,'LogASC')
 %  display('LogASC')
    %f = figure('Units', 'norm','Position',[0.5 0.4 0.55 0.6],'Name','Log Table');
    %uitable('Data',handles.LogASC{:,:},'ColumnName',handles.LogASC.Properties.VariableNames,'Units', 'Normalized', 'Position',[0, 0, 1, 1]);
    handles.LAStable=handles.LogASC;
    [m,n]=size(handles.LAStable{:,:});
     dd{2,n}=[];for jj=1:n;dd{1,jj}=false;end;dd(2,:)=handles.LAStable.Properties.VariableNames;
     %%dd{m+2,n}=[];%dd(3:m+2,1:n)=table2cell(handles.LAStable);
else
    set(handles.edit1,'String','No Logs Available');
    return;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 ff = figure('Position',[500 200 700 100],'Name','Select Logs');
handles.Slog = uitable(ff,'ColumnEditable',true);
handles.Slog.Data = dd;
handles.Slog.Position = [20 20 650 80];
guidata(hObject,handles);

btnM3 = uicontrol('Parent',ff,'Style', 'pushbutton', 'String', 'Save','Position', [600 50 50 30],'Callback','uiresume(gcbf)');
uiwait(gcf); 

if ~isvalid(handles.Slog);return;end
Slogdat= get(handles.Slog,'Data');
handles.LAStable(:,[Slogdat{1,:}]>0);
logUSED=handles.LAStable(:,[Slogdat{1,:}]>0);
handles.logUSED=logUSED;
handles.logUSEDNAMES=handles.LAStable.Properties.VariableNames(:,[Slogdat{1,:}]>0);
[mm,nn]=size(handles.logUSED);
handles.nn=nn;
guidata(hObject,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
d = figure('Units', 'norm','Position',[0 0.4 0.4 0.9],'Name','Assign Log Columns');
hdr=uicontrol('Parent',d,'Style', 'text', 'String', 'Match Logs ', 'Units', 'norm', 'Position', [0.4,0.85,0.2,0.06]);
stringvals={'DENS (g/cc)';'DT (usec/ft)';'DTS (usec/ft)';'VP (m/s)';'VS (m/s)';'PE';'K (Gpa)';'mu (Gpa)'; 'Depth';'Porosity'};
handles.stringvals=stringvals;
H=[];
for K = 1 : handles.nn
  H(K) = uicontrol('Parent',d,'Style', 'pop', 'String', stringvals, 'Units', 'norm', 'Position', [0.4,0.9-0.05*K,0.2,0.03]);
end

for K = 1 : handles.nn
  Htxt(K) = uicontrol('Parent',d,'Style', 'text', 'String', handles.logUSEDNAMES{K}, 'Units', 'norm', 'Position', [0.2,0.9-0.05*K,0.22,0.03]);
end
if isempty(H)
    set(handles.edit1,'String','No Constituents Selected')
    pause(1)
    set(handles.edit1,'String','Status')
    close(gcf);
   close(gcf);
return;
end
handles.H=H;
handles.Htxt=Htxt;
btnX=uicontrol('Parent',d,'Style', 'pushbutton', 'String', 'Save','Units', 'norm','Position',[0.65 0.65 0.1 0.06],'Callback','uiresume(gcbf)');
uiwait(gcf);
if ~isvalid(handles.Htxt);return;end
cnt=0;
for K = 1 : length(handles.H)
    valLoc(K) = get(handles.H(K),'Value');
    handles.valLoc(K) = valLoc(K);
    if handles.valLoc(K) ==10;handles.POR=handles.logUSED{:,K};end
    if handles.valLoc(K) ==9;handles.DEP=handles.logUSED{:,K}; end
    if (handles.valLoc(K) ~=9 && handles.valLoc(K) ~=10) 
        cnt=cnt+1;logLOC(cnt)=K;
    end
end
handles.logLOC=logLOC;
logFIN=logUSED{:,handles.logLOC};
handles.logFIN=logFIN;
handles.logFINNAMES=handles.logUSEDNAMES(:,handles.logLOC);

guidata(hObject,handles);
  
if ~isfield(handles,'logUSEDNAMES');handles.logUSEDNAMES='NONE';end
msg=['Logs Used: ' handles.logUSEDNAMES];
set(handles.listbox2_selectedinfo,'String',msg);
guidata(hObject,handles);
close(gcf);
close(gcf);


function btnX_callback(hObject, eventdata,handles)
guidata(hObject,handles);

function btnM3_callback(hObject, eventdata,handles)
guidata(hObject,handles);
 

% --- Executes on button press in pushbutton6_AssigLogs.
%%%%%% Assign Log Positions or select Logs
function pushbutton6_AssigLogs_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6_AssigLogs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



% --- Executes during object creation, after setting all properties.
%%%%%% title selected
function text7_selectedInfo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text7_selectedInfo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
%%%%%% title Method
function text6_MethodHeader_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text6_MethodHeader (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% % ----------------------------------------------------------------------
function viewlogss(hObject, eventdata, handles)

if isfield(handles,'logFIN')
    if isfield(handles,'logFINshort')
        if isfield(handles,'POR')
         porshort=handles.PORshort;
        end
    depshort=handles.DEPshort;
    logFINshort=handles.logFINshort;
    else
    if isfield(handles,'POR')
         porshort=handles.POR;
    end
    depshort=handles.DEP;
    logFINshort=handles.logFIN;  
    end
    panhandle = uipanel('Position', [0.258 0.124 0.689 0.746]);
    handles.panhandle=panhandle;
    [ml,nl]=size(logFINshort);
    numplts=nl+1;if isfield(handles,'POR'); numplts=nl+2;end
    handles.numplts=numplts;
    
    c=simpcol();
    
    for jj=1:nl
     handles.pax(jj,:)=subplot(1,numplts+1,jj,'Parent',handles.panhandle); 
     plot(logFINshort(:,jj),depshort,'Color',c(jj,:))
     title(handles.logFINNAMES(:,jj))
     ylim([handles.dtop handles.dbot]);
     %if (jj~=1);set(gca,'yticklabel',[]); end
     set(gca,'Ydir','reverse')
     grid on;
    end
    if isfield(handles,'POR')
       handles.pax(jj+1,:)= subplot(1,numplts+1,jj+1,'Parent',handles.panhandle) ;
     plot(porshort,depshort,'Color',c(jj+1,:))  
     title('Porosity (v/v)')
     ylim([handles.dtop handles.dbot]);
     %set(gca,'yticklabel',[]);
      set(gca,'Ydir','reverse')
     grid on;
    end
    if isfield(handles,'RESULT')
     subplot(1,numplts+1,[numplts numplts+1],'Parent',handles.panhandle)
     add_litho(hObject, eventdata, handles,depshort',handles.RESULT);
     ylim([handles.dtop handles.dbot]);
     grid on;
    end
    if isfield(handles,'RESULT2')
     handles.pax(numplts,:)=subplot(1,numplts+1,[numplts numplts+1],'Parent',handles.panhandle);
     add_litho2(hObject, eventdata, handles,depshort',handles.RESULT2);
     ylim([handles.dtop handles.dbot]);
    end
    guidata(hObject,handles);
  %%%%  
else
    set(handles.edit1,'String','First Load and Select Logs');
    return
end



function c=simpcol()
c =[
    0.1000    0.1000    0.9000
    0.1000    0.9000    0.1000
    0.1000    0.1552    0.1552
    0.9000    0.1552    0.6241
    0.9000    0.7621    0.4310
    0.1000    0.9000    0.9000
    0.1000    0.4862    0.9000
    0.9000    0.7345    0.8724
    0.5414    0.1552    0.1276
    0.1276    0.4586    0.1000
    0.3207    0.1000    0.4034
    0.7897    0.9000    0.1000
    0.7897    0.1000    0.9000
    0.1000    0.9000    0.5690
    0.4862    0.5966    0.5138
    0.7621    0.4862    0.9000
    0.9000    0.4586    0.1552
    0.4310    0.3483    0.1000
    0.1000    0.5690    0.7345
    0.5138    0.3483    0.4310
    0.9000    0.1000    0.3483
    0.1000    0.1828    0.6793
    0.9000    0.5690    0.5138
    0.7069    0.9000    0.6241
    0.1000    0.2655    0.4586
    0.5414    0.6241    0.1000
    0.5690    0.1000    0.3483
    0.5690    0.9000    0.3759
    0.8724    0.9000    0.8448
    0.5414    0.5414    0.7897
    0.1000    0.6517    0.4862
    0.9000    0.4586    0.6517
    0.1000    0.3207    0.1828
    0.6241    0.1276    0.6241
    0.2931    0.1276    0.1000
    0.9000    0.7621    0.1000
    0.7621    0.1000    0.1000
    0.5690    0.8172    0.9000
    0.5690    0.3207    0.9000
    0.1000    0.3759    0.4034
    0.1000    0.6517    0.1000
    0.6793    0.4862    0.1000
    0.2103    0.1000    0.2103
    0.4862    0.5966    0.3207
    0.3759    0.3207    0.6793
    0.6793    0.5690    0.4034
    0.8448    0.9000    0.4310
    0.3483    0.3483    0.2931
    0.6241    0.3207    0.5966
    0.9000    0.3759    0.3483
    0 0 1
    0 0 0
    0 1 0
    1 1 0];

function X=solveforX(hObject, eventdata, handles,A,B)
methodnameALL=get(handles.listbox1_methods,'string');
nomb = handles.listbox1_methods.Value;
methodname=methodnameALL(nomb);
if strcmp(methodname, 'Least Squares')
    X=lsqnonneg(A,B');
elseif strcmp(methodname, 'Moore-Penrose')
    X= pinv(A)*B';
elseif strcmp(methodname, 'luDecomposition')
    X=linsolve(A,B');
end


% --- Executes on button press in pushbutton10.
%%%Save Plots
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%%%%------------
if ~isfield(handles,'logFIN')
 set(handles.edit1,'String','Please Load data and Invert')
 return
end
set(handles.edit1,'String','Please Wait...Saving Plots...')
%close open figures
set(MinInversion, 'HandleVisibility', 'off');
close all;
set(MinInversion, 'HandleVisibility', 'on');


mkdir('./MinInversion_Output');
% PathName = uigetdir('./MinInversion_Output','Select Output Folder');
% if (PathName == 0)
% set(handles.edit1,'String','Output folder is not selected')
% pause(1)
% set(handles.edit1,'String','Status')
% return;
% end
PathName='./MinInversion_Output';
FileName1=['MinInversion_logs',datestr(now, 'dd_mmm_yyyy_HH_MM_SS'),'.fig'];
FileName2=['MinInversion_logs',datestr(now, 'dd_mmm_yyyy_HH_MM_SS'),'.png'];
saveName1 = fullfile(PathName,FileName1);
saveName2 = fullfile(PathName,FileName2);
hfig=figure('units','normalized','outerposition',[0 0 0.5 1]);
axes(gca);
c=simpcol();

if isfield(handles,'logFINshort')
    if isfield(handles,'POR')
         porshort=handles.PORshort;
    end
    depshort=handles.DEPshort;
    logFINshort=handles.logFINshort;
    else
    if isfield(handles,'POR')
         porshort=handles.POR;
    end
    depshort=handles.DEP;
    logFINshort=handles.logFIN;  
end

    [ml,nl]=size(logFINshort);
if ~isfield(handles,'numplts')
 set(handles.edit1,'String','Please Load data and Invert')
 return
end
    numplts=handles.numplts;
    for jj=1:nl
    subplot(1,numplts,jj); 
     plot(logFINshort(:,jj),depshort,'Color',c(jj,:),'Linewidth',3)
     title(handles.logFINNAMES(:,jj),'Fontsize',20)
     ylim([handles.dtop handles.dbot]);
     set(gca,'Ydir','reverse')
     grid on;
     box on;
    end
    if isfield(handles,'POR')
     subplot(1,numplts,jj+1) ;
     plot(porshort,depshort,'Color',c(jj+1,:),'Linewidth',3)  
     title('Porosity','Fontsize',20)
     ylim([handles.dtop handles.dbot]);
      set(gca,'Ydir','reverse')
     grid on;
     box on;
    end
saveas(hfig, saveName1,'fig');
saveas(hfig, saveName2,'png');
close(hfig);
 %%%%------------ 
FileName1=['MinInversion_VFrac',datestr(now, 'dd_mmm_yyyy_HH_MM_SS'),'.fig'];
FileName2=['MinInversion_VFrac',datestr(now, 'dd_mmm_yyyy_HH_MM_SS'),'.png'];
saveName1 = fullfile(PathName,FileName1);
saveName2 = fullfile(PathName,FileName2);
hfig=figure('units','normalized','outerposition',[0 0 0.5 1]);
if isfield(handles,'RESULT')
     add_litho(hObject, eventdata, handles,depshort',handles.RESULT);
     ylim([handles.dtop handles.dbot]);
     grid on;
end
if isfield(handles,'RESULT2')
     add_litho2(hObject, eventdata, handles,depshort',handles.RESULT2);
     ylim([handles.dtop handles.dbot]);
end
box on;
saveas(hfig, saveName1,'fig');
saveas(hfig, saveName2,'png');
close(hfig);
%%%%------------
FileName1=['MinInversion_LogsVFrac',datestr(now, 'dd_mmm_yyyy_HH_MM_SS'),'.fig'];
FileName2=['MinInversion_LogsVFrac',datestr(now, 'dd_mmm_yyyy_HH_MM_SS'),'.png'];
saveName1 = fullfile(PathName,FileName1);
saveName2 = fullfile(PathName,FileName2);
hfig=figure('units','normalized','outerposition',[0 0 0.8 1]);
for jj=1:nl
    subplot(1,numplts+1,jj); 
     plot(logFINshort(:,jj),depshort,'Color',c(jj,:),'Linewidth',3)
     title(handles.logFINNAMES(:,jj),'Fontsize',20)
     ylim([handles.dtop handles.dbot]);
     set(gca,'Ydir','reverse')
     grid on;
     box on;
end
if isfield(handles,'POR')
     subplot(1,numplts+1,jj+1) ;
     plot(porshort,depshort,'Color',c(jj+1,:),'Linewidth',3)  
     title('Porosity','Fontsize',20)
     ylim([handles.dtop handles.dbot]);
     %set(gca,'yticklabel',[]);
      set(gca,'Ydir','reverse')
     grid on;
     box on;
end

PathName='./MinInversion_Output';
FileName1txt=['MinInversion_Data',datestr(now, 'dd_mmm_yyyy_HH_MM_SS'),'.cmpn.dat'];
saveNametxt = fullfile(PathName,FileName1txt);

subplot(1,numplts+1,[numplts numplts+1]) ;
if isfield(handles,'RESULT')
     add_litho(hObject, eventdata, handles,depshort',handles.RESULT);
     ylim([handles.dtop handles.dbot]);
     grid on;
     BB=['Depth'; handles.ddUSED(:,1)];
%      [mb,nb]=size(BB);
%       BB=reshape(BB,nb,mb);
     AA=[depshort handles.Xp'];
     T = array2table(AA,'VariableNames',BB);
     writetable(T,saveNametxt)
end
if isfield(handles,'RESULT2')
     add_litho2(hObject, eventdata, handles,depshort',handles.RESULT2);
     ylim([handles.dtop handles.dbot]);
     grid on;
     BB=['Depth'; handles.ddUSED(:,1)];
%      [mb,nb]=size(BB);
%       BB=reshape(BB,nb,mb);
     AA=[depshort handles.Xp'];
     T = array2table(AA,'VariableNames',BB);
     writetable(T,saveNametxt)

end  
box on;

saveas(hfig, saveName1,'fig');
saveas(hfig, saveName2,'png');
close(hfig);

if isfield(handles,'POR')
FileName1=['MinInversion_JProbDis',datestr(now, 'dd_mmm_yyyy_HH_MM_SS'),'.fig'];
FileName2=['MinInversion_JProbDis',datestr(now, 'dd_mmm_yyyy_HH_MM_SS'),'.png'];
saveName1 = fullfile(PathName,FileName1);
saveName2 = fullfile(PathName,FileName2);
hfig=figure('Units', 'norm','Position',[0.4 0 0.6 0.9]);
probtrends(handles)   
saveas(hfig, saveName1,'fig');
saveas(hfig, saveName2,'png');
close(hfig);
end
set(handles.edit1,'String','Done')

%%%%------------    

function probtrends(handles)
ur=get(handles.radiobutton1,'Value');
if (ur ==1)
    if ~isfield(handles,'PORshort')
        set(handles.edit1,'No Porosity Log')
        return;
    end
por=handles.PORshort;
Xp=handles.Xp;
[md,nd]=size(Xp);
count=2;
for jj=1:md
    subplot(md,2,count)
    histogram2(Xp(jj,:),por','FaceColor','flat',...
        'ShowEmptyBins','on','DisplayStyle', 'tile');
   
    xlabel([ handles.ddUSED(jj,1) '(v/v)'] ,'Fontsize',20);
    ylabel('Porosity (v/v)','Fontsize',20); 
    zlabel('Frequency','Fontsize',20);
    ch=colorbar; 
    ylabel(ch,'Frequency','Fontsize',20);
    title('Joint Probability Distribution','Fontsize',20)
count=count+2;
end
count=1;
for jj=1:md
    subplot(md,2,count)
    histogram2(Xp(jj,:),por','FaceColor','flat',...
        'ShowEmptyBins','on');
    
    xlabel([handles.ddUSED(jj,1); '(v/v)'],'Fontsize',20);
    ylabel('Porosity (v/v)','Fontsize',20); 
    zlabel('Frequency','Fontsize',20);
    ch=colorbar; 
    ylabel(ch,'Frequency','Fontsize',20);
    title('Joint Probability Distribution','Fontsize',20)
     count=count+2;
end  
end

%%%%------------    


% --- Executes on button press in pushbutton11.
%%% Rest Button
function pushbutton11_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close(gcbf);
MinInversion;
clear all; clc;


% --- Executes on button press in pushbutton13.
function pushbutton13_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close(gcbf);
clear all; clc;
